package LATMOS::Accounts::Web::Controller::Json::Info;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Json::Info - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path {
    my ( $self, $c, $otype) = @_;

    my $base = $c->model('Accounts')->db;
    $otype ||= $c->req->param('otype') or return;

    my $name = $c->req->param('name') or return;

    my $object = $base->get_object($otype, $name) or return;

    my @infos;

    foreach my $attr (sort { $a cmp $b } $base->list_canonical_fields($otype, 'r')) {
        $base->check_acl($object, $attr, 'r') or next;
        my $val = $object->get_c_field($attr);
        my @vals = ref $val ? @{ $val } : $val;
        foreach (@vals) {
            push(@infos, { n => $attr, v => $_ });
        }
    }

    $c->stash->{data} = \@infos;
}

=encoding utf8

=head1 AUTHOR

olivier

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
